/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/InlineResponse400', 'model/PatchCustomerShippingAddressRequest', 'model/PostCustomerShippingAddressRequest', 'model/ShippingAddressListForCustomer', 'model/Tmsv2customersEmbeddedDefaultShippingAddress'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/InlineResponse400'), require('../model/PatchCustomerShippingAddressRequest'), require('../model/PostCustomerShippingAddressRequest'), require('../model/ShippingAddressListForCustomer'), require('../model/Tmsv2customersEmbeddedDefaultShippingAddress'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CustomerShippingAddressApi = factory(root.CyberSource.ApiClient, root.CyberSource.InlineResponse400, root.CyberSource.PatchCustomerShippingAddressRequest, root.CyberSource.PostCustomerShippingAddressRequest, root.CyberSource.ShippingAddressListForCustomer, root.CyberSource.Tmsv2customersEmbeddedDefaultShippingAddress);
  }
}(this, function(ApiClient, InlineResponse400, PatchCustomerShippingAddressRequest, PostCustomerShippingAddressRequest, ShippingAddressListForCustomer, Tmsv2customersEmbeddedDefaultShippingAddress) {
  'use strict';

  /**
   * CustomerShippingAddress service.
   * @module api/CustomerShippingAddressApi
   * @version 0.0.1
   */

  /**
   * Constructs a new CustomerShippingAddressApi. 
   * @alias module:api/CustomerShippingAddressApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(configObject, apiClient) {
    this.apiClient = apiClient || ApiClient.instance;

	this.apiClient.setConfiguration(configObject);
	

    /**
     * Callback function to receive the result of the deleteCustomerShippingAddress operation.
     * @callback module:api/CustomerShippingAddressApi~deleteCustomerShippingAddressCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a Customer Shipping Address
     * @param {String} customerTokenId The TokenId of a customer.
     * @param {String} shippingAddressTokenId The TokenId of an shipping address.
     * @param {Object} opts Optional parameters
     * @param {String} opts.profileId The id of a profile containing user specific TMS configuration.
     * @param {module:api/CustomerShippingAddressApi~deleteCustomerShippingAddressCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteCustomerShippingAddress = function(customerTokenId, shippingAddressTokenId, opts, callback) {
      opts = opts || {};
      var postBody = null;
      if ('DELETE' == 'POST') {
        postBody = '{}';
      }

      // verify the required parameter 'customerTokenId' is set
      if (customerTokenId === undefined || customerTokenId === null) {
        throw new Error("Missing the required parameter 'customerTokenId' when calling deleteCustomerShippingAddress");
      }

      // verify the required parameter 'shippingAddressTokenId' is set
      if (shippingAddressTokenId === undefined || shippingAddressTokenId === null) {
        throw new Error("Missing the required parameter 'shippingAddressTokenId' when calling deleteCustomerShippingAddress");
      }


      var pathParams = {
        'customerTokenId': customerTokenId,
        'shippingAddressTokenId': shippingAddressTokenId
      };
      var queryParams = {
      };
      var headerParams = {
        'profile-id': opts['profileId']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getCustomerShippingAddress operation.
     * @callback module:api/CustomerShippingAddressApi~getCustomerShippingAddressCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Tmsv2customersEmbeddedDefaultShippingAddress} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve a Customer Shipping Address
     * @param {String} customerTokenId The TokenId of a customer.
     * @param {String} shippingAddressTokenId The TokenId of an shipping address.
     * @param {Object} opts Optional parameters
     * @param {String} opts.profileId The id of a profile containing user specific TMS configuration.
     * @param {module:api/CustomerShippingAddressApi~getCustomerShippingAddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Tmsv2customersEmbeddedDefaultShippingAddress}
     */
    this.getCustomerShippingAddress = function(customerTokenId, shippingAddressTokenId, opts, callback) {
      opts = opts || {};
      var postBody = null;
      if ('GET' == 'POST') {
        postBody = '{}';
      }

      // verify the required parameter 'customerTokenId' is set
      if (customerTokenId === undefined || customerTokenId === null) {
        throw new Error("Missing the required parameter 'customerTokenId' when calling getCustomerShippingAddress");
      }

      // verify the required parameter 'shippingAddressTokenId' is set
      if (shippingAddressTokenId === undefined || shippingAddressTokenId === null) {
        throw new Error("Missing the required parameter 'shippingAddressTokenId' when calling getCustomerShippingAddress");
      }


      var pathParams = {
        'customerTokenId': customerTokenId,
        'shippingAddressTokenId': shippingAddressTokenId
      };
      var queryParams = {
      };
      var headerParams = {
        'profile-id': opts['profileId']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Tmsv2customersEmbeddedDefaultShippingAddress;

      return this.apiClient.callApi(
        '/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getCustomerShippingAddressesList operation.
     * @callback module:api/CustomerShippingAddressApi~getCustomerShippingAddressesListCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ShippingAddressListForCustomer} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Shipping Addresses for a Customer
     * @param {String} customerTokenId The TokenId of a customer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.profileId The id of a profile containing user specific TMS configuration.
     * @param {Number} opts.offset Starting record in zero-based dataset that should be returned as the first object in the array. Default is 0. (default to 0)
     * @param {Number} opts.limit The maximum number that can be returned in the array starting from the offset record in zero-based dataset. Default is 20, maximum is 100. (default to 20)
     * @param {module:api/CustomerShippingAddressApi~getCustomerShippingAddressesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ShippingAddressListForCustomer}
     */
    this.getCustomerShippingAddressesList = function(customerTokenId, opts, callback) {
      opts = opts || {};
      var postBody = null;
      if ('GET' == 'POST') {
        postBody = '{}';
      }

      // verify the required parameter 'customerTokenId' is set
      if (customerTokenId === undefined || customerTokenId === null) {
        throw new Error("Missing the required parameter 'customerTokenId' when calling getCustomerShippingAddressesList");
      }


      var pathParams = {
        'customerTokenId': customerTokenId
      };
      var queryParams = {
        'offset': opts['offset'],
        'limit': opts['limit']
      };
      var headerParams = {
        'profile-id': opts['profileId']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = ShippingAddressListForCustomer;

      return this.apiClient.callApi(
        '/tms/v2/customers/{customerTokenId}/shipping-addresses', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the patchCustomersShippingAddress operation.
     * @callback module:api/CustomerShippingAddressApi~patchCustomersShippingAddressCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Tmsv2customersEmbeddedDefaultShippingAddress} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a Customer Shipping Address
     * @param {String} customerTokenId The TokenId of a customer.
     * @param {String} shippingAddressTokenId The TokenId of an shipping address.
     * @param {module:model/PatchCustomerShippingAddressRequest} patchCustomerShippingAddressRequest 
     * @param {Object} opts Optional parameters
     * @param {String} opts.profileId The id of a profile containing user specific TMS configuration.
     * @param {String} opts.ifMatch Contains an ETag value from a GET request to make the request conditional.
     * @param {module:api/CustomerShippingAddressApi~patchCustomersShippingAddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Tmsv2customersEmbeddedDefaultShippingAddress}
     */
    this.patchCustomersShippingAddress = function(customerTokenId, shippingAddressTokenId, patchCustomerShippingAddressRequest, opts, callback) {
      opts = opts || {};
      var postBody = patchCustomerShippingAddressRequest;

      // verify the required parameter 'customerTokenId' is set
      if (customerTokenId === undefined || customerTokenId === null) {
        throw new Error("Missing the required parameter 'customerTokenId' when calling patchCustomersShippingAddress");
      }

      // verify the required parameter 'shippingAddressTokenId' is set
      if (shippingAddressTokenId === undefined || shippingAddressTokenId === null) {
        throw new Error("Missing the required parameter 'shippingAddressTokenId' when calling patchCustomersShippingAddress");
      }

      // verify the required parameter 'patchCustomerShippingAddressRequest' is set
      if (patchCustomerShippingAddressRequest === undefined || patchCustomerShippingAddressRequest === null) {
        throw new Error("Missing the required parameter 'patchCustomerShippingAddressRequest' when calling patchCustomersShippingAddress");
      }


      var pathParams = {
        'customerTokenId': customerTokenId,
        'shippingAddressTokenId': shippingAddressTokenId
      };
      var queryParams = {
      };
      var headerParams = {
        'profile-id': opts['profileId'],
        'if-match': opts['ifMatch']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Tmsv2customersEmbeddedDefaultShippingAddress;

      return this.apiClient.callApi(
        '/tms/v2/customers/{customerTokenId}/shipping-addresses/{shippingAddressTokenId}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the postCustomerShippingAddress operation.
     * @callback module:api/CustomerShippingAddressApi~postCustomerShippingAddressCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Tmsv2customersEmbeddedDefaultShippingAddress} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a Customer Shipping Address
     * Include an existing TMS Customer token id in the request URI. * A Customer token can be created by calling: **POST *_/tms/v2/customers*** 
     * @param {String} customerTokenId The TokenId of a customer.
     * @param {module:model/PostCustomerShippingAddressRequest} postCustomerShippingAddressRequest 
     * @param {Object} opts Optional parameters
     * @param {String} opts.profileId The id of a profile containing user specific TMS configuration.
     * @param {module:api/CustomerShippingAddressApi~postCustomerShippingAddressCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Tmsv2customersEmbeddedDefaultShippingAddress}
     */
    this.postCustomerShippingAddress = function(customerTokenId, postCustomerShippingAddressRequest, opts, callback) {
      opts = opts || {};
      var postBody = postCustomerShippingAddressRequest;

      // verify the required parameter 'customerTokenId' is set
      if (customerTokenId === undefined || customerTokenId === null) {
        throw new Error("Missing the required parameter 'customerTokenId' when calling postCustomerShippingAddress");
      }

      // verify the required parameter 'postCustomerShippingAddressRequest' is set
      if (postCustomerShippingAddressRequest === undefined || postCustomerShippingAddressRequest === null) {
        throw new Error("Missing the required parameter 'postCustomerShippingAddressRequest' when calling postCustomerShippingAddress");
      }


      var pathParams = {
        'customerTokenId': customerTokenId
      };
      var queryParams = {
      };
      var headerParams = {
        'profile-id': opts['profileId']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Tmsv2customersEmbeddedDefaultShippingAddress;

      return this.apiClient.callApi(
        '/tms/v2/customers/{customerTokenId}/shipping-addresses', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
