/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Tssv2transactionsemvTagDetailsEmvDetailsList'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Tssv2transactionsemvTagDetailsEmvDetailsList'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Body = factory(root.CyberSource.ApiClient, root.CyberSource.Tssv2transactionsemvTagDetailsEmvDetailsList);
  }
}(this, function(ApiClient, Tssv2transactionsemvTagDetailsEmvDetailsList) {
  'use strict';




  /**
   * The Body model module.
   * @module model/Body
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Body</code>.
   * @alias module:model/Body
   * @class
   * @param requestor {String} Identifies the service requesting parsing 
   * @param emvDetailsList {Array.<module:model/Tssv2transactionsemvTagDetailsEmvDetailsList>} An array of objects, each containing a requestId and the corresponding emvRequestCombinedTags 
   */
  var exports = function(requestor, emvDetailsList) {
    var _this = this;

    _this['requestor'] = requestor;

    _this['emvDetailsList'] = emvDetailsList;
  };

  /**
   * Constructs a <code>Body</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Body} obj Optional instance to populate.
   * @return {module:model/Body} The populated <code>Body</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('requestor')) {
        obj['requestor'] = ApiClient.convertToType(data['requestor'], 'String');
      }
      if (data.hasOwnProperty('parsedTagLimit')) {
        obj['parsedTagLimit'] = ApiClient.convertToType(data['parsedTagLimit'], 'Number');
      }
      if (data.hasOwnProperty('emvDetailsList')) {
        obj['emvDetailsList'] = ApiClient.convertToType(data['emvDetailsList'], [Tssv2transactionsemvTagDetailsEmvDetailsList]);
      }
    }
    return obj;
  }

  /**
   * Identifies the service requesting parsing 
   * @member {String} requestor
   */
  exports.prototype['requestor'] = undefined;
  /**
   * Number of tags to parse for each EMV tag string provided. 
   * @member {Number} parsedTagLimit
   */
  exports.prototype['parsedTagLimit'] = undefined;
  /**
   * An array of objects, each containing a requestId and the corresponding emvRequestCombinedTags 
   * @member {Array.<module:model/Tssv2transactionsemvTagDetailsEmvDetailsList>} emvDetailsList
   */
  exports.prototype['emvDetailsList'] = undefined;



  return exports;
}));


