/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.FlexV1KeysPost200ResponseJwk = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FlexV1KeysPost200ResponseJwk model module.
   * @module model/FlexV1KeysPost200ResponseJwk
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>FlexV1KeysPost200ResponseJwk</code>.
   * The public key in JSON Web Key (JWK) format. This format is useful for client side encryption in JavaScript based implementations.
   * @alias module:model/FlexV1KeysPost200ResponseJwk
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>FlexV1KeysPost200ResponseJwk</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FlexV1KeysPost200ResponseJwk} obj Optional instance to populate.
   * @return {module:model/FlexV1KeysPost200ResponseJwk} The populated <code>FlexV1KeysPost200ResponseJwk</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('kty')) {
        obj['kty'] = ApiClient.convertToType(data['kty'], 'String');
      }
      if (data.hasOwnProperty('use')) {
        obj['use'] = ApiClient.convertToType(data['use'], 'String');
      }
      if (data.hasOwnProperty('kid')) {
        obj['kid'] = ApiClient.convertToType(data['kid'], 'String');
      }
      if (data.hasOwnProperty('n')) {
        obj['n'] = ApiClient.convertToType(data['n'], 'String');
      }
      if (data.hasOwnProperty('e')) {
        obj['e'] = ApiClient.convertToType(data['e'], 'String');
      }
    }
    return obj;
  }

  /**
   * Algorithm used to encrypt the public key.
   * @member {String} kty
   */
  exports.prototype['kty'] = undefined;
  /**
   * Defines whether to use the key for encryption (enc) or verifying a signature (sig). Always returned as enc.
   * @member {String} use
   */
  exports.prototype['use'] = undefined;
  /**
   * The key ID in JWK format.
   * @member {String} kid
   */
  exports.prototype['kid'] = undefined;
  /**
   * JWK RSA Modulus
   * @member {String} n
   */
  exports.prototype['n'] = undefined;
  /**
   * JWK RSA Exponent
   * @member {String} e
   */
  exports.prototype['e'] = undefined;



  return exports;
}));


