/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Flexv1tokensCardInfo = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Flexv1tokensCardInfo model module.
   * @module model/Flexv1tokensCardInfo
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Flexv1tokensCardInfo</code>.
   * @alias module:model/Flexv1tokensCardInfo
   * @class
   * @param cardNumber {String} Encrypted or plain text card number. If the encryption type of “None” was used in the Generate Key request, this value can be set to the plaintext card number/Personal Account Number (PAN). If the encryption type of RsaOaep256 was used in the Generate Key request, this value needs to be the RSA OAEP 256 encrypted card number. The card number should be encrypted on the cardholders’ device. The [WebCrypto API] (https://github.com/CyberSource/cybersource-flex-samples/blob/master/java/spring-boot/src/main/resources/public/flex.js) can be used with the JWK obtained in the Generate Key request.
   * @param cardType {String} Card Type. This field is required. Refer to the CyberSource Credit Card Services documentation for supported card types.
   */
  var exports = function(cardNumber, cardType) {
    var _this = this;

    _this['cardNumber'] = cardNumber;


    _this['cardType'] = cardType;
  };

  /**
   * Constructs a <code>Flexv1tokensCardInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Flexv1tokensCardInfo} obj Optional instance to populate.
   * @return {module:model/Flexv1tokensCardInfo} The populated <code>Flexv1tokensCardInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('cardNumber')) {
        obj['cardNumber'] = ApiClient.convertToType(data['cardNumber'], 'String');
      }
      if (data.hasOwnProperty('cardExpirationMonth')) {
        obj['cardExpirationMonth'] = ApiClient.convertToType(data['cardExpirationMonth'], 'String');
      }
      if (data.hasOwnProperty('cardExpirationYear')) {
        obj['cardExpirationYear'] = ApiClient.convertToType(data['cardExpirationYear'], 'String');
      }
      if (data.hasOwnProperty('cardType')) {
        obj['cardType'] = ApiClient.convertToType(data['cardType'], 'String');
      }
    }
    return obj;
  }

  /**
   * Encrypted or plain text card number. If the encryption type of “None” was used in the Generate Key request, this value can be set to the plaintext card number/Personal Account Number (PAN). If the encryption type of RsaOaep256 was used in the Generate Key request, this value needs to be the RSA OAEP 256 encrypted card number. The card number should be encrypted on the cardholders’ device. The [WebCrypto API] (https://github.com/CyberSource/cybersource-flex-samples/blob/master/java/spring-boot/src/main/resources/public/flex.js) can be used with the JWK obtained in the Generate Key request.
   * @member {String} cardNumber
   */
  exports.prototype['cardNumber'] = undefined;
  /**
   * Two digit expiration month
   * @member {String} cardExpirationMonth
   */
  exports.prototype['cardExpirationMonth'] = undefined;
  /**
   * Four digit expiration year
   * @member {String} cardExpirationYear
   */
  exports.prototype['cardExpirationYear'] = undefined;
  /**
   * Card Type. This field is required. Refer to the CyberSource Credit Card Services documentation for supported card types.
   * @member {String} cardType
   */
  exports.prototype['cardType'] = undefined;



  return exports;
}));


