/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Flexv1tokensCardInfo'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Flexv1tokensCardInfo'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TokenizeRequest = factory(root.CyberSource.ApiClient, root.CyberSource.Flexv1tokensCardInfo);
  }
}(this, function(ApiClient, Flexv1tokensCardInfo) {
  'use strict';




  /**
   * The TokenizeRequest model module.
   * @module model/TokenizeRequest
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TokenizeRequest</code>.
   * @alias module:model/TokenizeRequest
   * @class
   * @param keyId {String} Unique identifier for the generated token. This is obtained from the Generate Key request. See the [Java Script and Java examples](http://apps.cybersource.com/library/documentation/dev_guides/Secure_Acceptance_Flex/Key/html) on how to import the key and encrypt using the imported key.
   */
  var exports = function(keyId) {
    var _this = this;

    _this['keyId'] = keyId;

  };

  /**
   * Constructs a <code>TokenizeRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TokenizeRequest} obj Optional instance to populate.
   * @return {module:model/TokenizeRequest} The populated <code>TokenizeRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('keyId')) {
        obj['keyId'] = ApiClient.convertToType(data['keyId'], 'String');
      }
      if (data.hasOwnProperty('cardInfo')) {
        obj['cardInfo'] = Flexv1tokensCardInfo.constructFromObject(data['cardInfo']);
      }
    }
    return obj;
  }

  /**
   * Unique identifier for the generated token. This is obtained from the Generate Key request. See the [Java Script and Java examples](http://apps.cybersource.com/library/documentation/dev_guides/Secure_Acceptance_Flex/Key/html) on how to import the key and encrypt using the imported key.
   * @member {String} keyId
   */
  exports.prototype['keyId'] = undefined;
  /**
   * @member {module:model/Flexv1tokensCardInfo} cardInfo
   */
  exports.prototype['cardInfo'] = undefined;



  return exports;
}));


